/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) mmap_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int long long int
#endif

/* Add prefix to internal symbols */
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_fill CASADI_PREFIX(fill)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

#ifndef casadi_inf
  #define casadi_inf INFINITY
#endif

void casadi_fill(casadi_real* x, casadi_int n, casadi_real alpha) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = alpha;
  }
}

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

static const casadi_int casadi_s0[4] = {0, 1, 0, 0};
static const casadi_int casadi_s1[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s2[6] = {2, 1, 0, 2, 0, 1};
static const casadi_int casadi_s3[8] = {4, 1, 0, 4, 0, 1, 2, 3};

/* mmap:(p[0],t)->(lbx,ubx,lbu,ubu,C[0],D[0],lg[0],ug[0],lh[0],uh[0],lbx_e[2],ubx_e[2],C_e[0],lg_e[0],ug_e[0],lbx_0[4],ubx_0[4]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real w0, *w1=w+1;
  /* #0: @0 = -0.25 */
  w0 = -2.5000000000000000e-01;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = inf */
  w0 = casadi_inf;
  /* #3: output[1][0] = @0 */
  if (res[1]) res[1][0] = w0;
  /* #4: @0 = -1 */
  w0 = -1.;
  /* #5: output[2][0] = @0 */
  if (res[2]) res[2][0] = w0;
  /* #6: @0 = 1 */
  w0 = 1.;
  /* #7: output[3][0] = @0 */
  if (res[3]) res[3][0] = w0;
  /* #8: @1 = all_-0.25(2x1) */
  casadi_fill(w1, 2, -2.5000000000000000e-01);
  /* #9: output[10][0] = @1 */
  casadi_copy(w1, 2, res[10]);
  /* #10: @1 = inf(2x1) */
  casadi_fill(w1, 2, casadi_inf);
  /* #11: output[11][0] = @1 */
  casadi_copy(w1, 2, res[11]);
  /* #12: @0 = -0.25 */
  w0 = -2.5000000000000000e-01;
  /* #13: output[15][0] = @0 */
  if (res[15]) res[15][0] = w0;
  /* #14: @0 = 0.1 */
  w0 = 1.0000000000000001e-01;
  /* #15: output[15][1] = @0 */
  if (res[15]) res[15][1] = w0;
  /* #16: @0 = 1 */
  w0 = 1.;
  /* #17: output[15][2] = @0 */
  if (res[15]) res[15][2] = w0;
  /* #18: @0 = 0 */
  w0 = 0.;
  /* #19: output[15][3] = @0 */
  if (res[15]) res[15][3] = w0;
  /* #20: @0 = inf */
  w0 = casadi_inf;
  /* #21: output[16][0] = @0 */
  if (res[16]) res[16][0] = w0;
  /* #22: @0 = 0.1 */
  w0 = 1.0000000000000001e-01;
  /* #23: output[16][1] = @0 */
  if (res[16]) res[16][1] = w0;
  /* #24: @0 = 1 */
  w0 = 1.;
  /* #25: output[16][2] = @0 */
  if (res[16]) res[16][2] = w0;
  /* #26: @0 = 0 */
  w0 = 0.;
  /* #27: output[16][3] = @0 */
  if (res[16]) res[16][3] = w0;
  return 0;
}

CASADI_SYMBOL_EXPORT int mmap(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int mmap_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int mmap_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void mmap_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int mmap_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void mmap_release(int mem) {
}

CASADI_SYMBOL_EXPORT void mmap_incref(void) {
}

CASADI_SYMBOL_EXPORT void mmap_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int mmap_n_in(void) { return 2;}

CASADI_SYMBOL_EXPORT casadi_int mmap_n_out(void) { return 17;}

CASADI_SYMBOL_EXPORT casadi_real mmap_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* mmap_name_in(casadi_int i){
  switch (i) {
    case 0: return "p";
    case 1: return "t";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* mmap_name_out(casadi_int i){
  switch (i) {
    case 0: return "lbx";
    case 1: return "ubx";
    case 2: return "lbu";
    case 3: return "ubu";
    case 4: return "C";
    case 5: return "D";
    case 6: return "lg";
    case 7: return "ug";
    case 8: return "lh";
    case 9: return "uh";
    case 10: return "lbx_e";
    case 11: return "ubx_e";
    case 12: return "C_e";
    case 13: return "lg_e";
    case 14: return "ug_e";
    case 15: return "lbx_0";
    case 16: return "ubx_0";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* mmap_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s0;
    case 1: return casadi_s1;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* mmap_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s1;
    case 1: return casadi_s1;
    case 2: return casadi_s1;
    case 3: return casadi_s1;
    case 4: return casadi_s0;
    case 5: return casadi_s0;
    case 6: return casadi_s0;
    case 7: return casadi_s0;
    case 8: return casadi_s0;
    case 9: return casadi_s0;
    case 10: return casadi_s2;
    case 11: return casadi_s2;
    case 12: return casadi_s0;
    case 13: return casadi_s0;
    case 14: return casadi_s0;
    case 15: return casadi_s3;
    case 16: return casadi_s3;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int mmap_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 2;
  if (sz_res) *sz_res = 18;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 3;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
