/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_ode_hess_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_c0 CASADI_PREFIX(c0)
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_mtimes CASADI_PREFIX(mtimes)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)
#define casadi_s6 CASADI_PREFIX(s6)
#define casadi_s7 CASADI_PREFIX(s7)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

void casadi_mtimes(const casadi_real* x, const casadi_int* sp_x, const casadi_real* y, const casadi_int* sp_y, casadi_real* z, const casadi_int* sp_z, casadi_real* w, casadi_int tr) {
  casadi_int ncol_x, ncol_y, ncol_z, cc;
  const casadi_int *colind_x, *row_x, *colind_y, *row_y, *colind_z, *row_z;
  ncol_x = sp_x[1];
  colind_x = sp_x+2; row_x = sp_x + 2 + ncol_x+1;
  ncol_y = sp_y[1];
  colind_y = sp_y+2; row_y = sp_y + 2 + ncol_y+1;
  ncol_z = sp_z[1];
  colind_z = sp_z+2; row_z = sp_z + 2 + ncol_z+1;
  if (tr) {
    for (cc=0; cc<ncol_z; ++cc) {
      casadi_int kk;
      for (kk=colind_y[cc]; kk<colind_y[cc+1]; ++kk) {
        w[row_y[kk]] = y[kk];
      }
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        casadi_int kk1;
        casadi_int rr = row_z[kk];
        for (kk1=colind_x[rr]; kk1<colind_x[rr+1]; ++kk1) {
          z[kk] += x[kk1] * w[row_x[kk1]];
        }
      }
    }
  } else {
    for (cc=0; cc<ncol_y; ++cc) {
      casadi_int kk;
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        w[row_z[kk]] = z[kk];
      }
      for (kk=colind_y[cc]; kk<colind_y[cc+1]; ++kk) {
        casadi_int kk1;
        casadi_int rr = row_y[kk];
        for (kk1=colind_x[rr]; kk1<colind_x[rr+1]; ++kk1) {
          w[row_x[kk1]] += x[kk1]*y[kk];
        }
      }
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        z[kk] = w[row_z[kk]];
      }
    }
  }
}

static const casadi_int casadi_s0[23] = {4, 4, 0, 4, 8, 12, 16, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3};
static const casadi_int casadi_s1[11] = {4, 4, 0, 1, 2, 3, 4, 3, 3, 3, 3};
static const casadi_int casadi_s2[7] = {3, 1, 0, 3, 0, 1, 2};
static const casadi_int casadi_s3[15] = {3, 3, 0, 3, 6, 9, 0, 1, 2, 0, 1, 2, 0, 1, 2};
static const casadi_int casadi_s4[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s5[3] = {0, 0, 0};
static const casadi_int casadi_s6[6] = {4, 1, 0, 2, 1, 3};
static const casadi_int casadi_s7[14] = {10, 1, 0, 10, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9};

static const casadi_real casadi_c0[4] = {0., 0., 0., 1.};

/* rockit_model_expl_ode_hess:(i0[3],i1[3x3],i2[3],i3[3],i4,i5[])->(o0[4x1,2nz],o1[10]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i, j;
  casadi_real *rr, *ss;
  const casadi_real *cs;
  casadi_real *w0=w+4, w1, w2, w3, *w4=w+10, *w5=w+26, *w6=w+35, *w7=w+47, *w8=w+59, *w9=w+63, *w13=w+79, *w14=w+95, *w15=w+99, *w16=w+103, w17, w18;
  /* #0: @0 = input[3][0] */
  casadi_copy(arg[3], 3, w0);
  /* #1: {@1, @2, @3} = vertsplit(@0) */
  w1 = w0[0];
  w2 = w0[1];
  w3 = w0[2];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @1 = input[4][0] */
  w1 = arg[4] ? arg[4][0] : 0;
  /* #4: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #5: @1 = (@1*@3) */
  w1 *= w3;
  /* #6: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #7: @1 = (@1+@2) */
  w1 += w2;
  /* #8: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  /* #9: @4 = zeros(4x4) */
  casadi_clear(w4, 16);
  /* #10: @5 = input[1][0] */
  casadi_copy(arg[1], 9, w5);
  /* #11: @0 = input[2][0] */
  casadi_copy(arg[2], 3, w0);
  /* #12: @6 = horzcat(@5, @0) */
  rr=w6;
  for (i=0, cs=w5; i<9; ++i) *rr++ = *cs++;
  for (i=0, cs=w0; i<3; ++i) *rr++ = *cs++;
  /* #13: @7 = @6' */
  for (i=0, rr=w7, cs=w6; i<4; ++i) for (j=0; j<3; ++j) rr[i+j*4] = *cs++;
  /* #14: @8 = [[0, 0, 0, 1]] */
  casadi_copy(casadi_c0, 4, w8);
  /* #15: @8 = @8' */
  /* #16: @9 = horzcat(@7, @8) */
  rr=w9;
  for (i=0, cs=w7; i<12; ++i) *rr++ = *cs++;
  for (i=0, cs=w8; i<4; ++i) *rr++ = *cs++;
  /* #17: @10 = 00 */
  /* #18: @11 = 00 */
  /* #19: @12 = 00 */
  /* #20: @13 = @9' */
  for (i=0, rr=w13, cs=w9; i<4; ++i) for (j=0; j<4; ++j) rr[i+j*4] = *cs++;
  /* #21: {@8, @14, @15, @16} = horzsplit(@13) */
  casadi_copy(w13, 4, w8);
  casadi_copy(w13+4, 4, w14);
  casadi_copy(w13+8, 4, w15);
  casadi_copy(w13+12, 4, w16);
  /* #22: {NULL, NULL, NULL, @1} = vertsplit(@8) */
  w1 = w8[3];
  /* #23: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #24: @1 = (@3*@1) */
  w1  = (w3*w1);
  /* #25: @2 = vertcat(@10, @11, @12, @1) */
  rr=(&w2);
  *rr++ = w1;
  /* #26: @10 = 00 */
  /* #27: @11 = 00 */
  /* #28: @12 = 00 */
  /* #29: {NULL, NULL, NULL, @1} = vertsplit(@14) */
  w1 = w14[3];
  /* #30: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #31: @1 = (@3*@1) */
  w1  = (w3*w1);
  /* #32: @17 = vertcat(@10, @11, @12, @1) */
  rr=(&w17);
  *rr++ = w1;
  /* #33: @10 = 00 */
  /* #34: @11 = 00 */
  /* #35: @12 = 00 */
  /* #36: {NULL, NULL, NULL, @1} = vertsplit(@15) */
  w1 = w15[3];
  /* #37: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #38: @1 = (@3*@1) */
  w1  = (w3*w1);
  /* #39: @18 = vertcat(@10, @11, @12, @1) */
  rr=(&w18);
  *rr++ = w1;
  /* #40: @10 = 00 */
  /* #41: @11 = 00 */
  /* #42: @12 = 00 */
  /* #43: {NULL, NULL, NULL, @1} = vertsplit(@16) */
  w1 = w16[3];
  /* #44: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #45: @3 = (@3*@1) */
  w3 *= w1;
  /* #46: @1 = vertcat(@10, @11, @12, @3) */
  rr=(&w1);
  *rr++ = w3;
  /* #47: @16 = horzcat(@2, @17, @18, @1) */
  rr=w16;
  *rr++ = w2;
  *rr++ = w17;
  *rr++ = w18;
  *rr++ = w1;
  /* #48: @4 = mac(@9,@16,@4) */
  casadi_mtimes(w9, casadi_s0, w16, casadi_s1, w4, casadi_s0, w, 0);
  /* #49: @2 = @4[0] */
  for (rr=(&w2), ss=w4+0; ss!=w4+1; ss+=1) *rr++ = *ss;
  /* #50: output[1][0] = @2 */
  if (res[1]) res[1][0] = w2;
  /* #51: @2 = @4[1] */
  for (rr=(&w2), ss=w4+1; ss!=w4+2; ss+=1) *rr++ = *ss;
  /* #52: output[1][1] = @2 */
  if (res[1]) res[1][1] = w2;
  /* #53: @2 = @4[2] */
  for (rr=(&w2), ss=w4+2; ss!=w4+3; ss+=1) *rr++ = *ss;
  /* #54: output[1][2] = @2 */
  if (res[1]) res[1][2] = w2;
  /* #55: @2 = @4[3] */
  for (rr=(&w2), ss=w4+3; ss!=w4+4; ss+=1) *rr++ = *ss;
  /* #56: output[1][3] = @2 */
  if (res[1]) res[1][3] = w2;
  /* #57: @2 = @4[5] */
  for (rr=(&w2), ss=w4+5; ss!=w4+6; ss+=1) *rr++ = *ss;
  /* #58: output[1][4] = @2 */
  if (res[1]) res[1][4] = w2;
  /* #59: @2 = @4[6] */
  for (rr=(&w2), ss=w4+6; ss!=w4+7; ss+=1) *rr++ = *ss;
  /* #60: output[1][5] = @2 */
  if (res[1]) res[1][5] = w2;
  /* #61: @2 = @4[7] */
  for (rr=(&w2), ss=w4+7; ss!=w4+8; ss+=1) *rr++ = *ss;
  /* #62: output[1][6] = @2 */
  if (res[1]) res[1][6] = w2;
  /* #63: @2 = @4[10] */
  for (rr=(&w2), ss=w4+10; ss!=w4+11; ss+=1) *rr++ = *ss;
  /* #64: output[1][7] = @2 */
  if (res[1]) res[1][7] = w2;
  /* #65: @2 = @4[11] */
  for (rr=(&w2), ss=w4+11; ss!=w4+12; ss+=1) *rr++ = *ss;
  /* #66: output[1][8] = @2 */
  if (res[1]) res[1][8] = w2;
  /* #67: @2 = @4[15] */
  for (rr=(&w2), ss=w4+15; ss!=w4+16; ss+=1) *rr++ = *ss;
  /* #68: output[1][9] = @2 */
  if (res[1]) res[1][9] = w2;
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_hess_n_in(void) { return 6;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_hess_n_out(void) { return 2;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_ode_hess_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_hess_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    case 4: return "i4";
    case 5: return "i5";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_hess_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    case 1: return "o1";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_hess_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s3;
    case 2: return casadi_s2;
    case 3: return casadi_s2;
    case 4: return casadi_s4;
    case 5: return casadi_s5;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_hess_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s6;
    case 1: return casadi_s7;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 10;
  if (sz_res) *sz_res = 6;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 109;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
