/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_vde_forw_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_densify CASADI_PREFIX(densify)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)
#define casadi_s6 CASADI_PREFIX(s6)
#define casadi_sq CASADI_PREFIX(sq)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

casadi_real casadi_sq(casadi_real x) { return x*x;}

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

#define CASADI_CAST(x,y) ((x) y)

void casadi_densify(const casadi_real* x, const casadi_int* sp_x, casadi_real* y, casadi_int tr) {
  casadi_int nrow_x, ncol_x, i, el;
  const casadi_int *colind_x, *row_x;
  if (!y) return;
  nrow_x = sp_x[0]; ncol_x = sp_x[1];
  colind_x = sp_x+2; row_x = sp_x+ncol_x+3;
  casadi_clear(y, nrow_x*ncol_x);
  if (!x) return;
  if (tr) {
    for (i=0; i<ncol_x; ++i) {
      for (el=colind_x[i]; el!=colind_x[i+1]; ++el) {
        y[i + row_x[el]*ncol_x] = CASADI_CAST(casadi_real, *x++);
      }
    }
  } else {
    for (i=0; i<ncol_x; ++i) {
      for (el=colind_x[i]; el!=colind_x[i+1]; ++el) {
        y[row_x[el]] = CASADI_CAST(casadi_real, *x++);
      }
      y += nrow_x;
    }
  }
}

static const casadi_int casadi_s0[6] = {3, 1, 0, 2, 1, 2};
static const casadi_int casadi_s1[5] = {3, 1, 0, 1, 0};
static const casadi_int casadi_s2[7] = {3, 1, 0, 3, 0, 1, 2};
static const casadi_int casadi_s3[15] = {3, 3, 0, 3, 6, 9, 0, 1, 2, 0, 1, 2, 0, 1, 2};
static const casadi_int casadi_s4[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s5[3] = {0, 0, 0};
static const casadi_int casadi_s6[9] = {3, 3, 0, 1, 2, 3, 0, 0, 0};

/* rockit_model_expl_vde_forw:(i0[3],i1[3x3],i2[3],i3,i4[])->(o0[3],o1[3x3,3nz],o2[3]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i;
  casadi_real *rr, *ss;
  const casadi_real *cs;
  casadi_real w0, w1, *w2=w+2, *w3=w+11, *w4=w+14, *w5=w+17, *w6=w+20, *w8=w+22, *w9=w+24;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = input[3][0] */
  w0 = arg[3] ? arg[3][0] : 0;
  /* #3: @1 = (2.*@0) */
  w1 = (2.* w0 );
  /* #4: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  /* #5: @1 = sq(@0) */
  w1 = casadi_sq( w0 );
  /* #6: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  /* #7: @2 = input[1][0] */
  casadi_copy(arg[1], 9, w2);
  /* #8: {@3, @4, @5} = horzsplit(@2) */
  casadi_copy(w2, 3, w3);
  casadi_copy(w2+3, 3, w4);
  casadi_copy(w2+6, 3, w5);
  /* #9: {NULL, @1, NULL} = vertsplit(@3) */
  w1 = w3[1];
  /* #10: output[1][0] = @1 */
  if (res[1]) res[1][0] = w1;
  /* #11: {NULL, @1, NULL} = vertsplit(@4) */
  w1 = w4[1];
  /* #12: output[1][1] = @1 */
  if (res[1]) res[1][1] = w1;
  /* #13: {NULL, @1, NULL} = vertsplit(@5) */
  w1 = w5[1];
  /* #14: output[1][2] = @1 */
  if (res[1]) res[1][2] = w1;
  /* #15: @6 = zeros(1x3,2nz) */
  casadi_clear(w6, 2);
  /* #16: @7 = 00 */
  /* #17: @1 = 2 */
  w1 = 2.;
  /* #18: @0 = (2.*@0) */
  w0 = (2.* w0 );
  /* #19: @8 = vertcat(@7, @1, @0) */
  rr=w8;
  *rr++ = w1;
  *rr++ = w0;
  /* #20: @9 = @8[:2] */
  for (rr=w9, ss=w8+0; ss!=w8+2; ss+=1) *rr++ = *ss;
  /* #21: (@6[:2] = @9) */
  for (rr=w6+0, ss=w9; rr!=w6+2; rr+=1) *rr = *ss++;
  /* #22: @6 = @6' */
  /* #23: @5 = dense(@6) */
  casadi_densify(w6, casadi_s0, w5, 0);
  /* #24: @4 = input[2][0] */
  casadi_copy(arg[2], 3, w4);
  /* #25: {NULL, @1, NULL} = vertsplit(@4) */
  w1 = w4[1];
  /* #26: @7 = 00 */
  /* #27: @10 = 00 */
  /* #28: @0 = vertcat(@1, @7, @10) */
  rr=(&w0);
  *rr++ = w1;
  /* #29: @4 = dense(@0) */
  casadi_densify((&w0), casadi_s1, w4, 0);
  /* #30: @5 = (@5+@4) */
  for (i=0, rr=w5, cs=w4; i<3; ++i) (*rr++) += (*cs++);
  /* #31: output[2][0] = @5 */
  casadi_copy(w5, 3, res[2]);
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_forw_n_in(void) { return 5;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_forw_n_out(void) { return 3;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_vde_forw_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_forw_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    case 4: return "i4";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_forw_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    case 1: return "o1";
    case 2: return "o2";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_forw_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s3;
    case 2: return casadi_s2;
    case 3: return casadi_s4;
    case 4: return casadi_s5;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_forw_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s6;
    case 2: return casadi_s2;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 8;
  if (sz_res) *sz_res = 6;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 26;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
