/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_constr_h_fun_jac_uxt_hess_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_fill CASADI_PREFIX(fill)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)
#define casadi_sq CASADI_PREFIX(sq)
#define casadi_trans CASADI_PREFIX(trans)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

casadi_real casadi_sq(casadi_real x) { return x*x;}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

void casadi_fill(casadi_real* x, casadi_int n, casadi_real alpha) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = alpha;
  }
}

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

void casadi_trans(const casadi_real* x, const casadi_int* sp_x, casadi_real* y,
    const casadi_int* sp_y, casadi_int* tmp) {
  casadi_int ncol_x, nnz_x, ncol_y, k;
  const casadi_int* row_x, *colind_y;
  ncol_x = sp_x[1];
  nnz_x = sp_x[2 + ncol_x];
  row_x = sp_x + 2 + ncol_x+1;
  ncol_y = sp_y[1];
  colind_y = sp_y+2;
  for (k=0; k<ncol_y; ++k) tmp[k] = colind_y[k];
  for (k=0; k<nnz_x; ++k) {
    y[tmp[row_x[k]]++] = x[k];
  }
}

static const casadi_int casadi_s0[7] = {3, 3, 0, 0, 1, 1, 1};
static const casadi_int casadi_s1[6] = {2, 1, 0, 2, 0, 1};
static const casadi_int casadi_s2[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s3[3] = {0, 0, 0};
static const casadi_int casadi_s4[6] = {3, 1, 0, 2, 1, 2};
static const casadi_int casadi_s5[3] = {1, 0, 0};

/* rockit_model_constr_h_fun_jac_uxt_hess:(i0[2],i1,i2,i3[],i4[])->(o0,o1[3x1,2nz],o2[3x3,1nz],o3[1x0],o4[]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *rr, *ss;
  casadi_real w0, w1, w2, w3, *w4=w+4, *w5=w+6, *w6=w+8;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: @1 = 0.01 */
  w1 = 1.0000000000000000e-02;
  /* #2: @2 = input[0][0] */
  w2 = arg[0] ? arg[0][0] : 0;
  /* #3: @3 = sq(@2) */
  w3 = casadi_sq( w2 );
  /* #4: @3 = (@1*@3) */
  w3  = (w1*w3);
  /* #5: @0 = (@0+@3) */
  w0 += w3;
  /* #6: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #7: @4 = zeros(3x1,2nz) */
  casadi_clear(w4, 2);
  /* #8: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #9: @5 = ones(3x1,2nz) */
  casadi_fill(w5, 2, 1.);
  /* #10: {NULL, @0, NULL} = vertsplit(@5) */
  w0 = w5[1];
  /* #11: @2 = (@2*@0) */
  w2 *= w0;
  /* #12: @2 = (@1*@2) */
  w2  = (w1*w2);
  /* #13: (@4[0] = @2) */
  for (rr=w4+0, ss=(&w2); rr!=w4+1; rr+=1) *rr = *ss++;
  /* #14: @2 = ones(3x1,1nz) */
  w2 = 1.;
  /* #15: {NULL, NULL, @0} = vertsplit(@2) */
  w0 = w2;
  /* #16: (@4[1] = @0) */
  for (rr=w4+1, ss=(&w0); rr!=w4+2; rr+=1) *rr = *ss++;
  /* #17: output[1][0] = @4 */
  casadi_copy(w4, 2, res[1]);
  /* #18: @0 = zeros(3x3,1nz) */
  w0 = 0.;
  /* #19: @2 = input[2][0] */
  w2 = arg[2] ? arg[2][0] : 0;
  /* #20: @1 = (@1*@2) */
  w1 *= w2;
  /* #21: @6 = ones(3x1) */
  casadi_fill(w6, 3, 1.);
  /* #22: {NULL, @2, NULL} = vertsplit(@6) */
  w2 = w6[1];
  /* #23: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #24: @1 = (@1*@2) */
  w1 *= w2;
  /* #25: (@0[0] = @1) */
  for (rr=(&w0)+0, ss=(&w1); rr!=(&w0)+1; rr+=1) *rr = *ss++;
  /* #26: @1 = @0' */
  casadi_trans((&w0),casadi_s0, (&w1), casadi_s0, iw);
  /* #27: output[2][0] = @1 */
  if (res[2]) res[2][0] = w1;
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_constr_h_fun_jac_uxt_hess(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_constr_h_fun_jac_uxt_hess_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_constr_h_fun_jac_uxt_hess_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_constr_h_fun_jac_uxt_hess_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_constr_h_fun_jac_uxt_hess_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_constr_h_fun_jac_uxt_hess_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_constr_h_fun_jac_uxt_hess_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_constr_h_fun_jac_uxt_hess_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_constr_h_fun_jac_uxt_hess_n_in(void) { return 5;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_constr_h_fun_jac_uxt_hess_n_out(void) { return 5;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_constr_h_fun_jac_uxt_hess_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_constr_h_fun_jac_uxt_hess_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    case 4: return "i4";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_constr_h_fun_jac_uxt_hess_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    case 1: return "o1";
    case 2: return "o2";
    case 3: return "o3";
    case 4: return "o4";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_constr_h_fun_jac_uxt_hess_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s1;
    case 1: return casadi_s2;
    case 2: return casadi_s2;
    case 3: return casadi_s3;
    case 4: return casadi_s3;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_constr_h_fun_jac_uxt_hess_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s4;
    case 2: return casadi_s0;
    case 3: return casadi_s5;
    case 4: return casadi_s3;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_constr_h_fun_jac_uxt_hess_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 7;
  if (sz_res) *sz_res = 8;
  if (sz_iw) *sz_iw = 4;
  if (sz_w) *sz_w = 11;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
