/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_ode_fun_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_f1 CASADI_PREFIX(f1)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

static const casadi_int casadi_s0[8] = {4, 1, 0, 4, 0, 1, 2, 3};
static const casadi_int casadi_s1[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s2[3] = {0, 0, 0};

/* ode:(x[4],u,z[0],p[0],t[1x1,0nz])->(ode[4],alg[0],quad[0]) */
static int casadi_f1(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real w0;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = input[1][0] */
  w0 = arg[1] ? arg[1][0] : 0;
  /* #3: @0 = (2.*@0) */
  w0 = (2.* w0 );
  /* #4: output[0][1] = @0 */
  if (res[0]) res[0][1] = w0;
  /* #5: @0 = 1 */
  w0 = 1.;
  /* #6: output[0][2] = @0 */
  if (res[0]) res[0][2] = w0;
  /* #7: @0 = 0 */
  w0 = 0.;
  /* #8: output[0][3] = @0 */
  if (res[0]) res[0][3] = w0;
  return 0;
}

/* rockit_model_expl_ode_fun:(i0[4],i1,i2[])->(o0[4]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i;
  casadi_real **res1=res+1, *rr;
  const casadi_real **arg1=arg+3, *cs;
  casadi_real w0, w1, w2, w3, *w4=w+5, *w8=w+9;
  /* #0: @0 = input[0][3] */
  w0 = arg[0] ? arg[0][3] : 0;
  /* #1: @1 = input[0][0] */
  w1 = arg[0] ? arg[0][0] : 0;
  /* #2: @2 = input[0][1] */
  w2 = arg[0] ? arg[0][1] : 0;
  /* #3: @3 = input[0][2] */
  w3 = arg[0] ? arg[0][2] : 0;
  /* #4: @4 = vertcat(@1, @2, @3, @0) */
  rr=w4;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w0;
  /* #5: @1 = input[1][0] */
  w1 = arg[1] ? arg[1][0] : 0;
  /* #6: @5 = 0x1 */
  /* #7: @6 = 0x1 */
  /* #8: @7 = 00 */
  /* #9: {@8, NULL, NULL} = ode(@4, @1, @5, @6, @7) */
  arg1[0]=w4;
  arg1[1]=(&w1);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  res1[0]=w8;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f1(arg1, res1, iw, w, 0)) return 1;
  /* #10: @8 = (@0*@8) */
  for (i=0, rr=w8, cs=w8; i<4; ++i) (*rr++)  = (w0*(*cs++));
  /* #11: output[0][0] = @8 */
  casadi_copy(w8, 4, res[0]);
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_fun(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_fun_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_fun_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_fun_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_fun_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_fun_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_fun_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_fun_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_fun_n_in(void) { return 3;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_fun_n_out(void) { return 1;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_ode_fun_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_fun_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_fun_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_fun_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s0;
    case 1: return casadi_s1;
    case 2: return casadi_s2;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_fun_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s0;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_fun_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 9;
  if (sz_res) *sz_res = 5;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 13;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
