/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_ode_hess_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_c0 CASADI_PREFIX(c0)
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_dot CASADI_PREFIX(dot)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_f1 CASADI_PREFIX(f1)
#define casadi_f2 CASADI_PREFIX(f2)
#define casadi_f3 CASADI_PREFIX(f3)
#define casadi_f4 CASADI_PREFIX(f4)
#define casadi_mtimes CASADI_PREFIX(mtimes)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)
#define casadi_s6 CASADI_PREFIX(s6)
#define casadi_s7 CASADI_PREFIX(s7)
#define casadi_s8 CASADI_PREFIX(s8)
#define casadi_sparsify CASADI_PREFIX(sparsify)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

casadi_real casadi_dot(casadi_int n, const casadi_real* x, const casadi_real* y) {
  casadi_int i;
  casadi_real r = 0;
  for (i=0; i<n; ++i) r += *x++ * *y++;
  return r;
}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

#define CASADI_CAST(x,y) ((x) y)

void casadi_sparsify(const casadi_real* x, casadi_real* y, const casadi_int* sp_y, casadi_int tr) {
  casadi_int nrow_y, ncol_y, i, el;
  const casadi_int *colind_y, *row_y;
  nrow_y = sp_y[0];
  ncol_y = sp_y[1];
  colind_y = sp_y+2; row_y = sp_y+ncol_y+3;
  if (tr) {
    for (i=0; i<ncol_y; ++i) {
      for (el=colind_y[i]; el!=colind_y[i+1]; ++el) {
        *y++ = CASADI_CAST(casadi_real, x[i + row_y[el]*ncol_y]);
      }
    }
  } else {
    for (i=0; i<ncol_y; ++i) {
      for (el=colind_y[i]; el!=colind_y[i+1]; ++el) {
        *y++ = CASADI_CAST(casadi_real, x[row_y[el]]);
      }
      x += nrow_y;
    }
  }
}

void casadi_mtimes(const casadi_real* x, const casadi_int* sp_x, const casadi_real* y, const casadi_int* sp_y, casadi_real* z, const casadi_int* sp_z, casadi_real* w, casadi_int tr) {
  casadi_int ncol_x, ncol_y, ncol_z, cc;
  const casadi_int *colind_x, *row_x, *colind_y, *row_y, *colind_z, *row_z;
  ncol_x = sp_x[1];
  colind_x = sp_x+2; row_x = sp_x + 2 + ncol_x+1;
  ncol_y = sp_y[1];
  colind_y = sp_y+2; row_y = sp_y + 2 + ncol_y+1;
  ncol_z = sp_z[1];
  colind_z = sp_z+2; row_z = sp_z + 2 + ncol_z+1;
  if (tr) {
    for (cc=0; cc<ncol_z; ++cc) {
      casadi_int kk;
      for (kk=colind_y[cc]; kk<colind_y[cc+1]; ++kk) {
        w[row_y[kk]] = y[kk];
      }
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        casadi_int kk1;
        casadi_int rr = row_z[kk];
        for (kk1=colind_x[rr]; kk1<colind_x[rr+1]; ++kk1) {
          z[kk] += x[kk1] * w[row_x[kk1]];
        }
      }
    }
  } else {
    for (cc=0; cc<ncol_y; ++cc) {
      casadi_int kk;
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        w[row_z[kk]] = z[kk];
      }
      for (kk=colind_y[cc]; kk<colind_y[cc+1]; ++kk) {
        casadi_int kk1;
        casadi_int rr = row_y[kk];
        for (kk1=colind_x[rr]; kk1<colind_x[rr+1]; ++kk1) {
          w[row_x[kk1]] += x[kk1]*y[kk];
        }
      }
      for (kk=colind_z[cc]; kk<colind_z[cc+1]; ++kk) {
        z[kk] = w[row_z[kk]];
      }
    }
  }
}

static const casadi_int casadi_s0[6] = {4, 1, 0, 2, 0, 1};
static const casadi_int casadi_s1[33] = {5, 5, 0, 5, 10, 15, 20, 25, 0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 0, 1, 2, 3, 4};
static const casadi_int casadi_s2[23] = {5, 5, 0, 3, 6, 9, 12, 15, 1, 3, 4, 1, 3, 4, 1, 3, 4, 1, 3, 4, 1, 3, 4};
static const casadi_int casadi_s3[8] = {4, 1, 0, 4, 0, 1, 2, 3};
static const casadi_int casadi_s4[23] = {4, 4, 0, 4, 8, 12, 16, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3};
static const casadi_int casadi_s5[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s6[3] = {0, 0, 0};
static const casadi_int casadi_s7[7] = {5, 1, 0, 3, 1, 3, 4};
static const casadi_int casadi_s8[19] = {15, 1, 0, 15, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14};

static const casadi_real casadi_c0[5] = {0., 0., 0., 0., 1.};

/* ode:(x[4],u,z[0],p[0],t[1x1,0nz])->(ode[4],alg[0],quad[0]) */
static int casadi_f1(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real w0;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = input[1][0] */
  w0 = arg[1] ? arg[1][0] : 0;
  /* #3: @0 = (2.*@0) */
  w0 = (2.* w0 );
  /* #4: output[0][1] = @0 */
  if (res[0]) res[0][1] = w0;
  /* #5: @0 = 1 */
  w0 = 1.;
  /* #6: output[0][2] = @0 */
  if (res[0]) res[0][2] = w0;
  /* #7: @0 = 0 */
  w0 = 0.;
  /* #8: output[0][3] = @0 */
  if (res[0]) res[0][3] = w0;
  return 0;
}

/* adj1_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],adj_ode[4],adj_alg[0],adj_quad[0])->(adj_x[4x1,1nz],adj_u,adj_z[0],adj_p[0],adj_t[1x1,0nz]) */
static int casadi_f2(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1, w2;
  /* #0: @0 = input[8][0] */
  casadi_copy(arg[8], 4, w0);
  /* #1: {@1, @2, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w2 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #4: output[1][0] = @2 */
  if (res[1]) res[1][0] = w2;
  return 0;
}

/* fwd5_adj1_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],adj_ode[4],adj_alg[0],adj_quad[0],out_adj_x[4x1,0nz],out_adj_u[1x1,0nz],out_adj_z[0],out_adj_p[0],out_adj_t[1x1,0nz],fwd_x[4x5],fwd_u[1x5],fwd_z[0x5],fwd_p[0x5],fwd_t[1x5,0nz],fwd_out_ode[4x5,0nz],fwd_out_alg[0x5],fwd_out_quad[0x5],fwd_adj_ode[4x5],fwd_adj_alg[0x5],fwd_adj_quad[0x5])->(fwd_adj_x[4x5,5nz],fwd_adj_u[1x5],fwd_adj_z[0x5],fwd_adj_p[0x5],fwd_adj_t[1x5,0nz]) */
static int casadi_f3(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1, w2, w3, w4, w5, w6;
  /* #0: @0 = input[24][0] */
  casadi_copy(arg[24], 4, w0);
  /* #1: {@1, @2, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w2 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @0 = input[24][1] */
  casadi_copy(arg[24] ? arg[24]+4 : 0, 4, w0);
  /* #4: {@1, @3, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w3 = w0[1];
  /* #5: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  /* #6: @0 = input[24][2] */
  casadi_copy(arg[24] ? arg[24]+8 : 0, 4, w0);
  /* #7: {@1, @4, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w4 = w0[1];
  /* #8: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  /* #9: @0 = input[24][3] */
  casadi_copy(arg[24] ? arg[24]+12 : 0, 4, w0);
  /* #10: {@1, @5, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w5 = w0[1];
  /* #11: output[0][3] = @1 */
  if (res[0]) res[0][3] = w1;
  /* #12: @0 = input[24][4] */
  casadi_copy(arg[24] ? arg[24]+16 : 0, 4, w0);
  /* #13: {@1, @6, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w6 = w0[1];
  /* #14: output[0][4] = @1 */
  if (res[0]) res[0][4] = w1;
  /* #15: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #16: output[1][0] = @2 */
  if (res[1]) res[1][0] = w2;
  /* #17: @3 = (2.*@3) */
  w3 = (2.* w3 );
  /* #18: output[1][1] = @3 */
  if (res[1]) res[1][1] = w3;
  /* #19: @4 = (2.*@4) */
  w4 = (2.* w4 );
  /* #20: output[1][2] = @4 */
  if (res[1]) res[1][2] = w4;
  /* #21: @5 = (2.*@5) */
  w5 = (2.* w5 );
  /* #22: output[1][3] = @5 */
  if (res[1]) res[1][3] = w5;
  /* #23: @6 = (2.*@6) */
  w6 = (2.* w6 );
  /* #24: output[1][4] = @6 */
  if (res[1]) res[1][4] = w6;
  return 0;
}

/* fwd5_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],fwd_x[4x5],fwd_u[1x5],fwd_z[0x5],fwd_p[0x5],fwd_t[1x5,0nz])->(fwd_ode[4x5,10nz],fwd_alg[0x5],fwd_quad[0x5]) */
static int casadi_f4(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1;
  /* #0: @0 = input[8][0] */
  casadi_copy(arg[8], 4, w0);
  /* #1: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @1 = input[9][0] */
  w1 = arg[9] ? arg[9][0] : 0;
  /* #4: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #5: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  /* #6: @0 = input[8][1] */
  casadi_copy(arg[8] ? arg[8]+4 : 0, 4, w0);
  /* #7: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #8: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  /* #9: @1 = input[9][1] */
  w1 = arg[9] ? arg[9][1] : 0;
  /* #10: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #11: output[0][3] = @1 */
  if (res[0]) res[0][3] = w1;
  /* #12: @0 = input[8][2] */
  casadi_copy(arg[8] ? arg[8]+8 : 0, 4, w0);
  /* #13: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #14: output[0][4] = @1 */
  if (res[0]) res[0][4] = w1;
  /* #15: @1 = input[9][2] */
  w1 = arg[9] ? arg[9][2] : 0;
  /* #16: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #17: output[0][5] = @1 */
  if (res[0]) res[0][5] = w1;
  /* #18: @0 = input[8][3] */
  casadi_copy(arg[8] ? arg[8]+12 : 0, 4, w0);
  /* #19: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #20: output[0][6] = @1 */
  if (res[0]) res[0][6] = w1;
  /* #21: @1 = input[9][3] */
  w1 = arg[9] ? arg[9][3] : 0;
  /* #22: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #23: output[0][7] = @1 */
  if (res[0]) res[0][7] = w1;
  /* #24: @0 = input[8][4] */
  casadi_copy(arg[8] ? arg[8]+16 : 0, 4, w0);
  /* #25: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #26: output[0][8] = @1 */
  if (res[0]) res[0][8] = w1;
  /* #27: @1 = input[9][4] */
  w1 = arg[9] ? arg[9][4] : 0;
  /* #28: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #29: output[0][9] = @1 */
  if (res[0]) res[0][9] = w1;
  return 0;
}

/* rockit_model_expl_ode_hess:(i0[4],i1[4x4],i2[4],i3[4],i4,i5[])->(o0[5x1,3nz],o1[15]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i, j;
  casadi_real **res1=res+2, *rr, *ss;
  const casadi_real **arg1=arg+6, *cr, *cs;
  casadi_real w0, w1, w2, w3, *w4=w+14, *w9=w+18, *w12=w+22, *w13=w+26, *w19=w+30, *w20=w+55, *w21=w+71, *w22=w+91, *w23=w+111, *w24=w+116, *w28=w+141, *w29=w+166, *w30=w+171, *w31=w+176, *w32=w+181, w33, w34, w35, w36, *w37=w+190, w38, w39, *w40=w+196, w41, w42, *w43=w+202, w44, w45, *w46=w+208, *w53=w+212, *w54=w+216, *w55=w+220, *w56=w+224, *w57=w+228, *w60=w+232, *w61=w+242, *w62=w+244, *w63=w+246, *w64=w+248, *w65=w+250, *w66=w+252, *w67=w+254, *w68=w+257, *w69=w+260, *w70=w+263, *w71=w+266, *w72=w+269;
  /* #0: @0 = input[0][0] */
  w0 = arg[0] ? arg[0][0] : 0;
  /* #1: @1 = input[0][1] */
  w1 = arg[0] ? arg[0][1] : 0;
  /* #2: @2 = input[0][2] */
  w2 = arg[0] ? arg[0][2] : 0;
  /* #3: @3 = input[0][3] */
  w3 = arg[0] ? arg[0][3] : 0;
  /* #4: @4 = vertcat(@0, @1, @2, @3) */
  rr=w4;
  *rr++ = w0;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  /* #5: @0 = input[4][0] */
  w0 = arg[4] ? arg[4][0] : 0;
  /* #6: @5 = 0x1 */
  /* #7: @6 = 0x1 */
  /* #8: @7 = 00 */
  /* #9: @8 = zeros(4x1,0nz) */
  /* #10: {@9, @10, @11} = ode(@4, @0, @5, @6, @7) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  res1[0]=w9;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f1(arg1, res1, iw, w, 0)) return 1;
  /* #11: @12 = input[3][0] */
  casadi_copy(arg[3], 4, w12);
  /* #12: @13 = (@3*@12) */
  for (i=0, rr=w13, cs=w12; i<4; ++i) (*rr++)  = (w3*(*cs++));
  /* #13: @14 = 0x1 */
  /* #14: @15 = 0x1 */
  /* #15: {@3, @1, @16, @17, @18} = adj1_ode(@4, @0, @5, @6, @7, @8, @10, @11, @13, @14, @15) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w13;
  arg1[9]=0;
  arg1[10]=0;
  res1[0]=(&w3);
  res1[1]=(&w1);
  res1[2]=0;
  res1[3]=0;
  res1[4]=0;
  if (casadi_f2(arg1, res1, iw, w, 0)) return 1;
  /* #16: {NULL, @2, NULL, NULL} = vertsplit(@3) */
  w2 = w3;
  /* #17: output[0][0] = @2 */
  if (res[0]) res[0][0] = w2;
  /* #18: @2 = dot(@9, @12) */
  w2 = casadi_dot(4, w9, w12);
  /* #19: output[0][1] = @2 */
  if (res[0]) res[0][1] = w2;
  /* #20: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  /* #21: @19 = zeros(5x5) */
  casadi_clear(w19, 25);
  /* #22: @20 = input[1][0] */
  casadi_copy(arg[1], 16, w20);
  /* #23: @9 = input[2][0] */
  casadi_copy(arg[2], 4, w9);
  /* #24: @21 = horzcat(@20, @9) */
  rr=w21;
  for (i=0, cs=w20; i<16; ++i) *rr++ = *cs++;
  for (i=0, cs=w9; i<4; ++i) *rr++ = *cs++;
  /* #25: @22 = @21' */
  for (i=0, rr=w22, cs=w21; i<5; ++i) for (j=0; j<4; ++j) rr[i+j*5] = *cs++;
  /* #26: @23 = [[0, 0, 0, 0, 1]] */
  casadi_copy(casadi_c0, 5, w23);
  /* #27: @23 = @23' */
  /* #28: @24 = horzcat(@22, @23) */
  rr=w24;
  for (i=0, cs=w22; i<20; ++i) *rr++ = *cs++;
  for (i=0, cs=w23; i<5; ++i) *rr++ = *cs++;
  /* #29: @25 = 00 */
  /* #30: @26 = zeros(4x1,0nz) */
  /* #31: @27 = 00 */
  /* #32: @28 = @24' */
  for (i=0, rr=w28, cs=w24; i<5; ++i) for (j=0; j<5; ++j) rr[i+j*5] = *cs++;
  /* #33: {@23, @29, @30, @31, @32} = horzsplit(@28) */
  casadi_copy(w28, 5, w23);
  casadi_copy(w28+5, 5, w29);
  casadi_copy(w28+10, 5, w30);
  casadi_copy(w28+15, 5, w31);
  casadi_copy(w28+20, 5, w32);
  /* #34: {@1, @2, @3, @33, @34} = vertsplit(@23) */
  w1 = w23[0];
  w2 = w23[1];
  w3 = w23[2];
  w33 = w23[3];
  w34 = w23[4];
  /* #35: @9 = vertcat(@1, @2, @3, @33) */
  rr=w9;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w33;
  /* #36: {@1, @2, @3, @35, @36} = vertsplit(@29) */
  w1 = w29[0];
  w2 = w29[1];
  w3 = w29[2];
  w35 = w29[3];
  w36 = w29[4];
  /* #37: @37 = vertcat(@1, @2, @3, @35) */
  rr=w37;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w35;
  /* #38: {@1, @2, @3, @38, @39} = vertsplit(@30) */
  w1 = w30[0];
  w2 = w30[1];
  w3 = w30[2];
  w38 = w30[3];
  w39 = w30[4];
  /* #39: @40 = vertcat(@1, @2, @3, @38) */
  rr=w40;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w38;
  /* #40: {@1, @2, @3, @41, @42} = vertsplit(@31) */
  w1 = w31[0];
  w2 = w31[1];
  w3 = w31[2];
  w41 = w31[3];
  w42 = w31[4];
  /* #41: @43 = vertcat(@1, @2, @3, @41) */
  rr=w43;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w41;
  /* #42: {@1, @2, @3, @44, @45} = vertsplit(@32) */
  w1 = w32[0];
  w2 = w32[1];
  w3 = w32[2];
  w44 = w32[3];
  w45 = w32[4];
  /* #43: @46 = vertcat(@1, @2, @3, @44) */
  rr=w46;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w44;
  /* #44: @22 = horzcat(@9, @37, @40, @43, @46) */
  rr=w22;
  for (i=0, cs=w9; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w37; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w40; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w43; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w46; i<4; ++i) *rr++ = *cs++;
  /* #45: @32 = horzcat(@34, @36, @39, @42, @45) */
  rr=w32;
  *rr++ = w34;
  *rr++ = w36;
  *rr++ = w39;
  *rr++ = w42;
  *rr++ = w45;
  /* #46: @47 = 0x5 */
  /* #47: @48 = 0x5 */
  /* #48: @49 = zeros(1x5,0nz) */
  /* #49: @50 = zeros(4x5,0nz) */
  /* #50: @51 = 0x5 */
  /* #51: @52 = 0x5 */
  /* #52: @53 = (@12*@33) */
  for (i=0, rr=w53, cr=w12; i<4; ++i) (*rr++)  = ((*cr++)*w33);
  /* #53: @54 = (@12*@35) */
  for (i=0, rr=w54, cr=w12; i<4; ++i) (*rr++)  = ((*cr++)*w35);
  /* #54: @55 = (@12*@38) */
  for (i=0, rr=w55, cr=w12; i<4; ++i) (*rr++)  = ((*cr++)*w38);
  /* #55: @56 = (@12*@41) */
  for (i=0, rr=w56, cr=w12; i<4; ++i) (*rr++)  = ((*cr++)*w41);
  /* #56: @57 = (@12*@44) */
  for (i=0, rr=w57, cr=w12; i<4; ++i) (*rr++)  = ((*cr++)*w44);
  /* #57: @21 = horzcat(@53, @54, @55, @56, @57) */
  rr=w21;
  for (i=0, cs=w53; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w54; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w55; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w56; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w57; i<4; ++i) *rr++ = *cs++;
  /* #58: @58 = 0x5 */
  /* #59: @59 = 0x5 */
  /* #60: {@31, @30, NULL, NULL, NULL} = fwd5_adj1_ode(@4, @0, @5, @6, @7, @8, @10, @11, @13, @14, @15, @26, @27, @16, @17, @18, @22, @32, @47, @48, @49, @50, @51, @52, @21, @58, @59) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w13;
  arg1[9]=0;
  arg1[10]=0;
  arg1[11]=0;
  arg1[12]=0;
  arg1[13]=0;
  arg1[14]=0;
  arg1[15]=0;
  arg1[16]=w22;
  arg1[17]=w32;
  arg1[18]=0;
  arg1[19]=0;
  arg1[20]=0;
  arg1[21]=0;
  arg1[22]=0;
  arg1[23]=0;
  arg1[24]=w21;
  arg1[25]=0;
  arg1[26]=0;
  res1[0]=w31;
  res1[1]=w30;
  res1[2]=0;
  res1[3]=0;
  res1[4]=0;
  if (casadi_f3(arg1, res1, iw, w, 0)) return 1;
  /* #61: {@44, @41, @38, @35, @33} = horzsplit(@31) */
  w44 = w31[0];
  w41 = w31[1];
  w38 = w31[2];
  w35 = w31[3];
  w33 = w31[4];
  /* #62: {NULL, @1, NULL, NULL} = vertsplit(@44) */
  w1 = w44;
  /* #63: @8 = 00 */
  /* #64: @14 = zeros(4x1,0nz) */
  /* #65: @22 = horzcat(@9, @37, @40, @43, @46) */
  rr=w22;
  for (i=0, cs=w9; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w37; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w40; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w43; i<4; ++i) *rr++ = *cs++;
  for (i=0, cs=w46; i<4; ++i) *rr++ = *cs++;
  /* #66: @31 = horzcat(@34, @36, @39, @42, @45) */
  rr=w31;
  *rr++ = w34;
  *rr++ = w36;
  *rr++ = w39;
  *rr++ = w42;
  *rr++ = w45;
  /* #67: @15 = 0x5 */
  /* #68: @26 = 0x5 */
  /* #69: @27 = zeros(1x5,0nz) */
  /* #70: {@60, NULL, NULL} = fwd5_ode(@4, @0, @5, @6, @7, @14, @10, @11, @22, @31, @15, @26, @27) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w22;
  arg1[9]=w31;
  arg1[10]=0;
  arg1[11]=0;
  arg1[12]=0;
  res1[0]=w60;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f4(arg1, res1, iw, w, 0)) return 1;
  /* #71: {@61, @62, @63, @64, @65} = horzsplit(@60) */
  casadi_copy(w60, 2, w61);
  casadi_copy(w60+2, 2, w62);
  casadi_copy(w60+4, 2, w63);
  casadi_copy(w60+6, 2, w64);
  casadi_copy(w60+8, 2, w65);
  /* #72: @66 = project(@12) */
  casadi_sparsify(w12, w66, casadi_s0, 0);
  /* #73: @0 = dot(@61, @66) */
  w0 = casadi_dot(2, w61, w66);
  /* #74: {@34, @36, @39, @42, @45} = horzsplit(@30) */
  w34 = w30[0];
  w36 = w30[1];
  w39 = w30[2];
  w42 = w30[3];
  w45 = w30[4];
  /* #75: @67 = vertcat(@25, @1, @8, @0, @34) */
  rr=w67;
  *rr++ = w1;
  *rr++ = w0;
  *rr++ = w34;
  /* #76: @25 = 00 */
  /* #77: {NULL, @1, NULL, NULL} = vertsplit(@41) */
  w1 = w41;
  /* #78: @8 = 00 */
  /* #79: @61 = project(@12) */
  casadi_sparsify(w12, w61, casadi_s0, 0);
  /* #80: @41 = dot(@62, @61) */
  w41 = casadi_dot(2, w62, w61);
  /* #81: @68 = vertcat(@25, @1, @8, @41, @36) */
  rr=w68;
  *rr++ = w1;
  *rr++ = w41;
  *rr++ = w36;
  /* #82: @25 = 00 */
  /* #83: {NULL, @1, NULL, NULL} = vertsplit(@38) */
  w1 = w38;
  /* #84: @8 = 00 */
  /* #85: @62 = project(@12) */
  casadi_sparsify(w12, w62, casadi_s0, 0);
  /* #86: @38 = dot(@63, @62) */
  w38 = casadi_dot(2, w63, w62);
  /* #87: @69 = vertcat(@25, @1, @8, @38, @39) */
  rr=w69;
  *rr++ = w1;
  *rr++ = w38;
  *rr++ = w39;
  /* #88: @25 = 00 */
  /* #89: {NULL, @1, NULL, NULL} = vertsplit(@35) */
  w1 = w35;
  /* #90: @8 = 00 */
  /* #91: @63 = project(@12) */
  casadi_sparsify(w12, w63, casadi_s0, 0);
  /* #92: @35 = dot(@64, @63) */
  w35 = casadi_dot(2, w64, w63);
  /* #93: @70 = vertcat(@25, @1, @8, @35, @42) */
  rr=w70;
  *rr++ = w1;
  *rr++ = w35;
  *rr++ = w42;
  /* #94: @25 = 00 */
  /* #95: {NULL, @1, NULL, NULL} = vertsplit(@33) */
  w1 = w33;
  /* #96: @8 = 00 */
  /* #97: @64 = project(@12) */
  casadi_sparsify(w12, w64, casadi_s0, 0);
  /* #98: @33 = dot(@65, @64) */
  w33 = casadi_dot(2, w65, w64);
  /* #99: @71 = vertcat(@25, @1, @8, @33, @45) */
  rr=w71;
  *rr++ = w1;
  *rr++ = w33;
  *rr++ = w45;
  /* #100: @72 = horzcat(@67, @68, @69, @70, @71) */
  rr=w72;
  for (i=0, cs=w67; i<3; ++i) *rr++ = *cs++;
  for (i=0, cs=w68; i<3; ++i) *rr++ = *cs++;
  for (i=0, cs=w69; i<3; ++i) *rr++ = *cs++;
  for (i=0, cs=w70; i<3; ++i) *rr++ = *cs++;
  for (i=0, cs=w71; i<3; ++i) *rr++ = *cs++;
  /* #101: @19 = mac(@24,@72,@19) */
  casadi_mtimes(w24, casadi_s1, w72, casadi_s2, w19, casadi_s1, w, 0);
  /* #102: @1 = @19[0] */
  for (rr=(&w1), ss=w19+0; ss!=w19+1; ss+=1) *rr++ = *ss;
  /* #103: output[1][0] = @1 */
  if (res[1]) res[1][0] = w1;
  /* #104: @1 = @19[1] */
  for (rr=(&w1), ss=w19+1; ss!=w19+2; ss+=1) *rr++ = *ss;
  /* #105: output[1][1] = @1 */
  if (res[1]) res[1][1] = w1;
  /* #106: @1 = @19[2] */
  for (rr=(&w1), ss=w19+2; ss!=w19+3; ss+=1) *rr++ = *ss;
  /* #107: output[1][2] = @1 */
  if (res[1]) res[1][2] = w1;
  /* #108: @1 = @19[3] */
  for (rr=(&w1), ss=w19+3; ss!=w19+4; ss+=1) *rr++ = *ss;
  /* #109: output[1][3] = @1 */
  if (res[1]) res[1][3] = w1;
  /* #110: @1 = @19[4] */
  for (rr=(&w1), ss=w19+4; ss!=w19+5; ss+=1) *rr++ = *ss;
  /* #111: output[1][4] = @1 */
  if (res[1]) res[1][4] = w1;
  /* #112: @1 = @19[6] */
  for (rr=(&w1), ss=w19+6; ss!=w19+7; ss+=1) *rr++ = *ss;
  /* #113: output[1][5] = @1 */
  if (res[1]) res[1][5] = w1;
  /* #114: @1 = @19[7] */
  for (rr=(&w1), ss=w19+7; ss!=w19+8; ss+=1) *rr++ = *ss;
  /* #115: output[1][6] = @1 */
  if (res[1]) res[1][6] = w1;
  /* #116: @1 = @19[8] */
  for (rr=(&w1), ss=w19+8; ss!=w19+9; ss+=1) *rr++ = *ss;
  /* #117: output[1][7] = @1 */
  if (res[1]) res[1][7] = w1;
  /* #118: @1 = @19[9] */
  for (rr=(&w1), ss=w19+9; ss!=w19+10; ss+=1) *rr++ = *ss;
  /* #119: output[1][8] = @1 */
  if (res[1]) res[1][8] = w1;
  /* #120: @1 = @19[12] */
  for (rr=(&w1), ss=w19+12; ss!=w19+13; ss+=1) *rr++ = *ss;
  /* #121: output[1][9] = @1 */
  if (res[1]) res[1][9] = w1;
  /* #122: @1 = @19[13] */
  for (rr=(&w1), ss=w19+13; ss!=w19+14; ss+=1) *rr++ = *ss;
  /* #123: output[1][10] = @1 */
  if (res[1]) res[1][10] = w1;
  /* #124: @1 = @19[14] */
  for (rr=(&w1), ss=w19+14; ss!=w19+15; ss+=1) *rr++ = *ss;
  /* #125: output[1][11] = @1 */
  if (res[1]) res[1][11] = w1;
  /* #126: @1 = @19[18] */
  for (rr=(&w1), ss=w19+18; ss!=w19+19; ss+=1) *rr++ = *ss;
  /* #127: output[1][12] = @1 */
  if (res[1]) res[1][12] = w1;
  /* #128: @1 = @19[19] */
  for (rr=(&w1), ss=w19+19; ss!=w19+20; ss+=1) *rr++ = *ss;
  /* #129: output[1][13] = @1 */
  if (res[1]) res[1][13] = w1;
  /* #130: @1 = @19[24] */
  for (rr=(&w1), ss=w19+24; ss!=w19+25; ss+=1) *rr++ = *ss;
  /* #131: output[1][14] = @1 */
  if (res[1]) res[1][14] = w1;
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_ode_hess_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_hess_n_in(void) { return 6;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_ode_hess_n_out(void) { return 2;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_ode_hess_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_hess_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    case 4: return "i4";
    case 5: return "i5";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_ode_hess_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    case 1: return "o1";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_hess_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s3;
    case 1: return casadi_s4;
    case 2: return casadi_s3;
    case 3: return casadi_s3;
    case 4: return casadi_s5;
    case 5: return casadi_s6;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_ode_hess_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s7;
    case 1: return casadi_s8;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_ode_hess_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 34;
  if (sz_res) *sz_res = 11;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 284;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
