/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_vde_adj_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_dot CASADI_PREFIX(dot)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_f1 CASADI_PREFIX(f1)
#define casadi_f2 CASADI_PREFIX(f2)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

casadi_real casadi_dot(casadi_int n, const casadi_real* x, const casadi_real* y) {
  casadi_int i;
  casadi_real r = 0;
  for (i=0; i<n; ++i) r += *x++ * *y++;
  return r;
}

static const casadi_int casadi_s0[8] = {4, 1, 0, 4, 0, 1, 2, 3};
static const casadi_int casadi_s1[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s2[3] = {0, 0, 0};
static const casadi_int casadi_s3[7] = {5, 1, 0, 3, 1, 3, 4};

/* ode:(x[4],u,z[0],p[0],t[1x1,0nz])->(ode[4],alg[0],quad[0]) */
static int casadi_f1(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real w0;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = input[1][0] */
  w0 = arg[1] ? arg[1][0] : 0;
  /* #3: @0 = (2.*@0) */
  w0 = (2.* w0 );
  /* #4: output[0][1] = @0 */
  if (res[0]) res[0][1] = w0;
  /* #5: @0 = 1 */
  w0 = 1.;
  /* #6: output[0][2] = @0 */
  if (res[0]) res[0][2] = w0;
  /* #7: @0 = 0 */
  w0 = 0.;
  /* #8: output[0][3] = @0 */
  if (res[0]) res[0][3] = w0;
  return 0;
}

/* adj1_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],adj_ode[4],adj_alg[0],adj_quad[0])->(adj_x[4x1,1nz],adj_u,adj_z[0],adj_p[0],adj_t[1x1,0nz]) */
static int casadi_f2(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1, w2;
  /* #0: @0 = input[8][0] */
  casadi_copy(arg[8], 4, w0);
  /* #1: {@1, @2, NULL, NULL} = vertsplit(@0) */
  w1 = w0[0];
  w2 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @2 = (2.*@2) */
  w2 = (2.* w2 );
  /* #4: output[1][0] = @2 */
  if (res[1]) res[1][0] = w2;
  return 0;
}

/* rockit_model_expl_vde_adj:(i0[4],i1[4],i2,i3[])->(o0[5x1,3nz]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i;
  casadi_real **res1=res+1, *rr;
  const casadi_real **arg1=arg+4, *cs;
  casadi_real w0, w1, w2, w3, *w4=w+10, *w9=w+14, *w12=w+18, *w13=w+22;
  /* #0: @0 = input[0][0] */
  w0 = arg[0] ? arg[0][0] : 0;
  /* #1: @1 = input[0][1] */
  w1 = arg[0] ? arg[0][1] : 0;
  /* #2: @2 = input[0][2] */
  w2 = arg[0] ? arg[0][2] : 0;
  /* #3: @3 = input[0][3] */
  w3 = arg[0] ? arg[0][3] : 0;
  /* #4: @4 = vertcat(@0, @1, @2, @3) */
  rr=w4;
  *rr++ = w0;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  /* #5: @0 = input[2][0] */
  w0 = arg[2] ? arg[2][0] : 0;
  /* #6: @5 = 0x1 */
  /* #7: @6 = 0x1 */
  /* #8: @7 = 00 */
  /* #9: @8 = zeros(4x1,0nz) */
  /* #10: {@9, @10, @11} = ode(@4, @0, @5, @6, @7) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  res1[0]=w9;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f1(arg1, res1, iw, w, 0)) return 1;
  /* #11: @12 = input[1][0] */
  casadi_copy(arg[1], 4, w12);
  /* #12: @13 = (@3*@12) */
  for (i=0, rr=w13, cs=w12; i<4; ++i) (*rr++)  = (w3*(*cs++));
  /* #13: @14 = 0x1 */
  /* #14: @15 = 0x1 */
  /* #15: {@3, @1, NULL, NULL, NULL} = adj1_ode(@4, @0, @5, @6, @7, @8, @10, @11, @13, @14, @15) */
  arg1[0]=w4;
  arg1[1]=(&w0);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w13;
  arg1[9]=0;
  arg1[10]=0;
  res1[0]=(&w3);
  res1[1]=(&w1);
  res1[2]=0;
  res1[3]=0;
  res1[4]=0;
  if (casadi_f2(arg1, res1, iw, w, 0)) return 1;
  /* #16: {NULL, @0, NULL, NULL} = vertsplit(@3) */
  w0 = w3;
  /* #17: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #18: @0 = dot(@9, @12) */
  w0 = casadi_dot(4, w9, w12);
  /* #19: output[0][1] = @0 */
  if (res[0]) res[0][1] = w0;
  /* #20: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_adj(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_adj_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_adj_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_adj_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_adj_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_adj_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_adj_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_adj_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_adj_n_in(void) { return 4;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_adj_n_out(void) { return 1;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_vde_adj_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_adj_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_adj_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_adj_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s0;
    case 1: return casadi_s0;
    case 2: return casadi_s1;
    case 3: return casadi_s2;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_adj_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s3;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_adj_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 16;
  if (sz_res) *sz_res = 10;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 26;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
