/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) rockit_model_expl_vde_forw_ ## ID
#endif

#include <math.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int int
#endif

/* Add prefix to internal symbols */
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_densify CASADI_PREFIX(densify)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_f1 CASADI_PREFIX(f1)
#define casadi_f2 CASADI_PREFIX(f2)
#define casadi_f3 CASADI_PREFIX(f3)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

#define CASADI_CAST(x,y) ((x) y)

void casadi_densify(const casadi_real* x, const casadi_int* sp_x, casadi_real* y, casadi_int tr) {
  casadi_int nrow_x, ncol_x, i, el;
  const casadi_int *colind_x, *row_x;
  if (!y) return;
  nrow_x = sp_x[0]; ncol_x = sp_x[1];
  colind_x = sp_x+2; row_x = sp_x+ncol_x+3;
  casadi_clear(y, nrow_x*ncol_x);
  if (!x) return;
  if (tr) {
    for (i=0; i<ncol_x; ++i) {
      for (el=colind_x[i]; el!=colind_x[i+1]; ++el) {
        y[i + row_x[el]*ncol_x] = CASADI_CAST(casadi_real, *x++);
      }
    }
  } else {
    for (i=0; i<ncol_x; ++i) {
      for (el=colind_x[i]; el!=colind_x[i+1]; ++el) {
        y[row_x[el]] = CASADI_CAST(casadi_real, *x++);
      }
      y += nrow_x;
    }
  }
}

static const casadi_int casadi_s0[6] = {4, 1, 0, 2, 0, 1};
static const casadi_int casadi_s1[5] = {4, 1, 0, 1, 1};
static const casadi_int casadi_s2[8] = {4, 1, 0, 4, 0, 1, 2, 3};
static const casadi_int casadi_s3[23] = {4, 4, 0, 4, 8, 12, 16, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3, 0, 1, 2, 3};
static const casadi_int casadi_s4[5] = {1, 1, 0, 1, 0};
static const casadi_int casadi_s5[3] = {0, 0, 0};

/* ode:(x[4],u,z[0],p[0],t[1x1,0nz])->(ode[4],alg[0],quad[0]) */
static int casadi_f1(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real w0;
  /* #0: @0 = input[0][1] */
  w0 = arg[0] ? arg[0][1] : 0;
  /* #1: output[0][0] = @0 */
  if (res[0]) res[0][0] = w0;
  /* #2: @0 = input[1][0] */
  w0 = arg[1] ? arg[1][0] : 0;
  /* #3: @0 = (2.*@0) */
  w0 = (2.* w0 );
  /* #4: output[0][1] = @0 */
  if (res[0]) res[0][1] = w0;
  /* #5: @0 = 1 */
  w0 = 1.;
  /* #6: output[0][2] = @0 */
  if (res[0]) res[0][2] = w0;
  /* #7: @0 = 0 */
  w0 = 0.;
  /* #8: output[0][3] = @0 */
  if (res[0]) res[0][3] = w0;
  return 0;
}

/* fwd4_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],fwd_x[4x4],fwd_u[1x4],fwd_z[0x4],fwd_p[0x4],fwd_t[1x4,0nz])->(fwd_ode[4x4,8nz],fwd_alg[0x4],fwd_quad[0x4]) */
static int casadi_f2(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1;
  /* #0: @0 = input[8][0] */
  casadi_copy(arg[8], 4, w0);
  /* #1: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @1 = input[9][0] */
  w1 = arg[9] ? arg[9][0] : 0;
  /* #4: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #5: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  /* #6: @0 = input[8][1] */
  casadi_copy(arg[8] ? arg[8]+4 : 0, 4, w0);
  /* #7: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #8: output[0][2] = @1 */
  if (res[0]) res[0][2] = w1;
  /* #9: @1 = input[9][1] */
  w1 = arg[9] ? arg[9][1] : 0;
  /* #10: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #11: output[0][3] = @1 */
  if (res[0]) res[0][3] = w1;
  /* #12: @0 = input[8][2] */
  casadi_copy(arg[8] ? arg[8]+8 : 0, 4, w0);
  /* #13: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #14: output[0][4] = @1 */
  if (res[0]) res[0][4] = w1;
  /* #15: @1 = input[9][2] */
  w1 = arg[9] ? arg[9][2] : 0;
  /* #16: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #17: output[0][5] = @1 */
  if (res[0]) res[0][5] = w1;
  /* #18: @0 = input[8][3] */
  casadi_copy(arg[8] ? arg[8]+12 : 0, 4, w0);
  /* #19: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #20: output[0][6] = @1 */
  if (res[0]) res[0][6] = w1;
  /* #21: @1 = input[9][3] */
  w1 = arg[9] ? arg[9][3] : 0;
  /* #22: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #23: output[0][7] = @1 */
  if (res[0]) res[0][7] = w1;
  return 0;
}

/* fwd1_ode:(x[4],u,z[0],p[0],t[1x1,0nz],out_ode[4x1,0nz],out_alg[0],out_quad[0],fwd_x[4],fwd_u,fwd_z[0],fwd_p[0],fwd_t[1x1,0nz])->(fwd_ode[4x1,2nz],fwd_alg[0],fwd_quad[0]) */
static int casadi_f3(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_real *w0=w+0, w1;
  /* #0: @0 = input[8][0] */
  casadi_copy(arg[8], 4, w0);
  /* #1: {NULL, @1, NULL, NULL} = vertsplit(@0) */
  w1 = w0[1];
  /* #2: output[0][0] = @1 */
  if (res[0]) res[0][0] = w1;
  /* #3: @1 = input[9][0] */
  w1 = arg[9] ? arg[9][0] : 0;
  /* #4: @1 = (2.*@1) */
  w1 = (2.* w1 );
  /* #5: output[0][1] = @1 */
  if (res[0]) res[0][1] = w1;
  return 0;
}

/* rockit_model_expl_vde_forw:(i0[4],i1[4x4],i2[4],i3,i4[])->(o0[4],o1[4x4],o2[4]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  casadi_int i;
  casadi_real **res1=res+3, *rr, *ss;
  const casadi_real **arg1=arg+5, *cr, *cs;
  casadi_real w0, w1, w2, w3, *w4=w+9, *w8=w+13, *w11=w+17, *w12=w+21, *w13=w+37, *w14=w+41, *w15=w+45, *w17=w+49, *w21=w+53, *w22=w+61, *w23=w+63, *w24=w+65, *w25=w+67;
  /* #0: @0 = input[0][3] */
  w0 = arg[0] ? arg[0][3] : 0;
  /* #1: @1 = input[0][0] */
  w1 = arg[0] ? arg[0][0] : 0;
  /* #2: @2 = input[0][1] */
  w2 = arg[0] ? arg[0][1] : 0;
  /* #3: @3 = input[0][2] */
  w3 = arg[0] ? arg[0][2] : 0;
  /* #4: @4 = vertcat(@1, @2, @3, @0) */
  rr=w4;
  *rr++ = w1;
  *rr++ = w2;
  *rr++ = w3;
  *rr++ = w0;
  /* #5: @1 = input[3][0] */
  w1 = arg[3] ? arg[3][0] : 0;
  /* #6: @5 = 0x1 */
  /* #7: @6 = 0x1 */
  /* #8: @7 = 00 */
  /* #9: {@8, @9, @10} = ode(@4, @1, @5, @6, @7) */
  arg1[0]=w4;
  arg1[1]=(&w1);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  res1[0]=w8;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f1(arg1, res1, iw, w, 0)) return 1;
  /* #10: @11 = (@0*@8) */
  for (i=0, rr=w11, cs=w8; i<4; ++i) (*rr++)  = (w0*(*cs++));
  /* #11: output[0][0] = @11 */
  casadi_copy(w11, 4, res[0]);
  /* #12: @12 = input[1][0] */
  casadi_copy(arg[1], 16, w12);
  /* #13: {@11, @13, @14, @15} = horzsplit(@12) */
  casadi_copy(w12, 4, w11);
  casadi_copy(w12+4, 4, w13);
  casadi_copy(w12+8, 4, w14);
  casadi_copy(w12+12, 4, w15);
  /* #14: {NULL, NULL, NULL, @2} = vertsplit(@11) */
  w2 = w11[3];
  /* #15: @11 = (@8*@2) */
  for (i=0, rr=w11, cr=w8; i<4; ++i) (*rr++)  = ((*cr++)*w2);
  /* #16: @16 = zeros(4x1,0nz) */
  /* #17: @17 = zeros(1x4) */
  casadi_clear(w17, 4);
  /* #18: @18 = 0x4 */
  /* #19: @19 = 0x4 */
  /* #20: @20 = zeros(1x4,0nz) */
  /* #21: {@21, NULL, NULL} = fwd4_ode(@4, @1, @5, @6, @7, @16, @9, @10, @12, @17, @18, @19, @20) */
  arg1[0]=w4;
  arg1[1]=(&w1);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w12;
  arg1[9]=w17;
  arg1[10]=0;
  arg1[11]=0;
  arg1[12]=0;
  res1[0]=w21;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f2(arg1, res1, iw, w, 0)) return 1;
  /* #22: {@22, @23, @24, @25} = horzsplit(@21) */
  casadi_copy(w21, 2, w22);
  casadi_copy(w21+2, 2, w23);
  casadi_copy(w21+4, 2, w24);
  casadi_copy(w21+6, 2, w25);
  /* #23: @22 = (@0*@22) */
  for (i=0, rr=w22, cs=w22; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #24: @17 = dense(@22) */
  casadi_densify(w22, casadi_s0, w17, 0);
  /* #25: @11 = (@11+@17) */
  for (i=0, rr=w11, cs=w17; i<4; ++i) (*rr++) += (*cs++);
  /* #26: output[1][0] = @11 */
  casadi_copy(w11, 4, res[1]);
  /* #27: {NULL, NULL, NULL, @2} = vertsplit(@13) */
  w2 = w13[3];
  /* #28: @13 = (@8*@2) */
  for (i=0, rr=w13, cr=w8; i<4; ++i) (*rr++)  = ((*cr++)*w2);
  /* #29: @23 = (@0*@23) */
  for (i=0, rr=w23, cs=w23; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #30: @11 = dense(@23) */
  casadi_densify(w23, casadi_s0, w11, 0);
  /* #31: @13 = (@13+@11) */
  for (i=0, rr=w13, cs=w11; i<4; ++i) (*rr++) += (*cs++);
  /* #32: output[1][1] = @13 */
  if (res[1]) casadi_copy(w13, 4, res[1]+4);
  /* #33: {NULL, NULL, NULL, @2} = vertsplit(@14) */
  w2 = w14[3];
  /* #34: @14 = (@8*@2) */
  for (i=0, rr=w14, cr=w8; i<4; ++i) (*rr++)  = ((*cr++)*w2);
  /* #35: @24 = (@0*@24) */
  for (i=0, rr=w24, cs=w24; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #36: @13 = dense(@24) */
  casadi_densify(w24, casadi_s0, w13, 0);
  /* #37: @14 = (@14+@13) */
  for (i=0, rr=w14, cs=w13; i<4; ++i) (*rr++) += (*cs++);
  /* #38: output[1][2] = @14 */
  if (res[1]) casadi_copy(w14, 4, res[1]+8);
  /* #39: {NULL, NULL, NULL, @2} = vertsplit(@15) */
  w2 = w15[3];
  /* #40: @15 = (@8*@2) */
  for (i=0, rr=w15, cr=w8; i<4; ++i) (*rr++)  = ((*cr++)*w2);
  /* #41: @25 = (@0*@25) */
  for (i=0, rr=w25, cs=w25; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #42: @14 = dense(@25) */
  casadi_densify(w25, casadi_s0, w14, 0);
  /* #43: @15 = (@15+@14) */
  for (i=0, rr=w15, cs=w14; i<4; ++i) (*rr++) += (*cs++);
  /* #44: output[1][3] = @15 */
  if (res[1]) casadi_copy(w15, 4, res[1]+12);
  /* #45: @2 = zeros(1x4,1nz) */
  w2 = 0.;
  /* #46: @16 = zeros(4x1,0nz) */
  /* #47: @15 = zeros(4x1) */
  casadi_clear(w15, 4);
  /* #48: @3 = 1 */
  w3 = 1.;
  /* #49: @18 = 0x1 */
  /* #50: @19 = 0x1 */
  /* #51: @20 = 00 */
  /* #52: {@25, NULL, NULL} = fwd1_ode(@4, @1, @5, @6, @7, @16, @9, @10, @15, @3, @18, @19, @20) */
  arg1[0]=w4;
  arg1[1]=(&w1);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w15;
  arg1[9]=(&w3);
  arg1[10]=0;
  arg1[11]=0;
  arg1[12]=0;
  res1[0]=w25;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f3(arg1, res1, iw, w, 0)) return 1;
  /* #53: @25 = (@0*@25) */
  for (i=0, rr=w25, cs=w25; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #54: @3 = @25[1] */
  for (rr=(&w3), ss=w25+1; ss!=w25+2; ss+=1) *rr++ = *ss;
  /* #55: (@2[0] = @3) */
  for (rr=(&w2)+0, ss=(&w3); rr!=(&w2)+1; rr+=1) *rr = *ss++;
  /* #56: @2 = @2' */
  /* #57: @15 = dense(@2) */
  casadi_densify((&w2), casadi_s1, w15, 0);
  /* #58: @14 = input[2][0] */
  casadi_copy(arg[2], 4, w14);
  /* #59: {NULL, NULL, NULL, @2} = vertsplit(@14) */
  w2 = w14[3];
  /* #60: @8 = (@8*@2) */
  for (i=0, rr=w8; i<4; ++i) (*rr++) *= w2;
  /* #61: @16 = zeros(4x1,0nz) */
  /* #62: @2 = 0 */
  w2 = 0.;
  /* #63: @18 = 0x1 */
  /* #64: @19 = 0x1 */
  /* #65: @20 = 00 */
  /* #66: {@25, NULL, NULL} = fwd1_ode(@4, @1, @5, @6, @7, @16, @9, @10, @14, @2, @18, @19, @20) */
  arg1[0]=w4;
  arg1[1]=(&w1);
  arg1[2]=0;
  arg1[3]=0;
  arg1[4]=0;
  arg1[5]=0;
  arg1[6]=0;
  arg1[7]=0;
  arg1[8]=w14;
  arg1[9]=(&w2);
  arg1[10]=0;
  arg1[11]=0;
  arg1[12]=0;
  res1[0]=w25;
  res1[1]=0;
  res1[2]=0;
  if (casadi_f3(arg1, res1, iw, w, 0)) return 1;
  /* #67: @25 = (@0*@25) */
  for (i=0, rr=w25, cs=w25; i<2; ++i) (*rr++)  = (w0*(*cs++));
  /* #68: @4 = dense(@25) */
  casadi_densify(w25, casadi_s0, w4, 0);
  /* #69: @8 = (@8+@4) */
  for (i=0, rr=w8, cs=w4; i<4; ++i) (*rr++) += (*cs++);
  /* #70: @15 = (@15+@8) */
  for (i=0, rr=w15, cs=w8; i<4; ++i) (*rr++) += (*cs++);
  /* #71: output[2][0] = @15 */
  casadi_copy(w15, 4, res[2]);
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_alloc_mem(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_init_mem(int mem) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_free_mem(int mem) {
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_checkout(void) {
  return 0;
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_release(int mem) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_incref(void) {
}

CASADI_SYMBOL_EXPORT void rockit_model_expl_vde_forw_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_forw_n_in(void) { return 5;}

CASADI_SYMBOL_EXPORT casadi_int rockit_model_expl_vde_forw_n_out(void) { return 3;}

CASADI_SYMBOL_EXPORT casadi_real rockit_model_expl_vde_forw_default_in(casadi_int i){
  switch (i) {
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_forw_name_in(casadi_int i){
  switch (i) {
    case 0: return "i0";
    case 1: return "i1";
    case 2: return "i2";
    case 3: return "i3";
    case 4: return "i4";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* rockit_model_expl_vde_forw_name_out(casadi_int i){
  switch (i) {
    case 0: return "o0";
    case 1: return "o1";
    case 2: return "o2";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_forw_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s3;
    case 2: return casadi_s2;
    case 3: return casadi_s4;
    case 4: return casadi_s5;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* rockit_model_expl_vde_forw_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s2;
    case 1: return casadi_s3;
    case 2: return casadi_s2;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int rockit_model_expl_vde_forw_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 19;
  if (sz_res) *sz_res = 10;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 69;
  return 0;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
